package spring;

import org.aspectj.lang.JoinPoint;
import org.aspectj.lang.JoinPoint.StaticPart;
import org.aspectj.lang.ProceedingJoinPoint;


public class PersonLogger {

	public void logMethodEntry(JoinPoint joinPoint) {

		Object[] args = joinPoint.getArgs();
		String name = joinPoint.getSignature().toShortString();

		StringBuffer stringBuffer = new StringBuffer(name + " called with: [");

		for (int i = 0; i < args.length; i++) {
			Object para = args[i];
			stringBuffer.append("'" + para + "'");
			stringBuffer.append((i == args.length - 1) ? "" : ", ");
		}
		stringBuffer.append("]");
		System.out.println(stringBuffer.toString());
	}

	public Object aroundAdvice(ProceedingJoinPoint joinPoint) throws Throwable {
		System.out.println("I'm listening");
		System.out.println("Start executing the method : "
				+ joinPoint.getSignature().toShortString());
		Object obj = joinPoint.proceed();
		System.out.println("Speech over");
		return obj;
	}

	public void logMethodExit(StaticPart staticPart, Object result) {
		String name = staticPart.getSignature().toShortString();
		System.out.println(name + " returning: [" + result + "]");
	}
	
	public void throwingAdvice(Exception ex) {
		System.out.println(ex.getMessage());
	}
}
